Index: /trunk/src/sys/arch/mips/mips/mipsX_subr.S
===================================================================
--- /trunk/src/sys/arch/mips/mips/mipsX_subr.S	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mipsX_subr.S	(revision 152)
@@ -2241,451 +2496,161 @@
 	or	a1, MIPS3_PG_G
 	_MTC0	a1, MIPS_COP_0_TLB_LO0		# upte[0] | PG_G
-	COP0_SYNC
 	or	a2, MIPS3_PG_G
 	_MTC0	a2, MIPS_COP_0_TLB_LO1		# upte[1] | PG_G
 	COP0_SYNC
-	nop
-	nop
 	tlbwi					# set TLB entry #0
 	COP0_SYNC
-	nop
-	nop
-
+	_MTC0	t3, MIPS_COP_0_TLB_HI		# restore TLB_HI
+	COP0_SYNC
+#if defined(MULTIPROCESSOR) && (MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+	INT_S	zero, 0(a3)			# clear tlb lock
+#endif
 MIPSX(resume):
 #endif /* !ENABLE_MIPS_16KB_PAGE || VMSWAP_UAREA */
+#if (MIPS32R2 + MIPS64R2 + MIPS64R2_RMIXL) > 0
+	PTR_L	v0, L_PRIVATE(a0)		# get lwp private
+	_MTC0	v0, MIPS_COP_0_TLB_CONTEXT, 4	# make available for rdhwr
+#endif
 	j	ra
-	nop
+	 nop
 END(MIPSX(cpu_switch_resume))
 
-/*
- * void mipsN_tlb_invalidate_addr(vaddr_t va)
- *
- * Invalidate a TLB entry which has the given vaddr and ASID if found.
- */
-LEAF_NOPROFILE(MIPSX(tlb_invalidate_addr))
-	mfc0	v1, MIPS_COP_0_STATUS		# save status register
-	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
-	COP0_SYNC
-
-	li	v0, (MIPS3_PG_HVPN | MIPS3_PG_ASID)
-	_MFC0	t0, MIPS_COP_0_TLB_HI		# save current ASID
-	mfc0	t3, MIPS_COP_0_TLB_PG_MASK	# save current pgMask
-	and	a0, v0				# make sure valid entryHi
-	_MTC0	a0, MIPS_COP_0_TLB_HI		# look for the vaddr & ASID
-	COP0_SYNC
-	nop
-	nop
-	tlbp					# probe the entry in question
-	COP0_SYNC
-	nop
-	nop
-	mfc0	v0, MIPS_COP_0_TLB_INDEX	# see what we got
-	#nop					# -slip-
-	#nop					# -slip-
-	bltz	v0, 1f				# index < 0 then skip
-	 li	t1, MIPS_KSEG0_START		# invalid address
-	PTR_SLL	v0, PGSHIFT + 1			# PAGE_SHIFT + 1
-	PTR_ADDU t1, v0
-	_MTC0	t1, MIPS_COP_0_TLB_HI		# make entryHi invalid
-	COP0_SYNC
-	_MTC0	zero, MIPS_COP_0_TLB_LO0	# zero out entryLo0
-	COP0_SYNC
-	_MTC0	zero, MIPS_COP_0_TLB_LO1	# zero out entryLo1
-	COP0_SYNC
-#if 1
-	nop
-#else
-	mtc0	zero, MIPS_COP_0_TLB_PG_MASK	# zero out pageMask
-#endif
-	COP0_SYNC
-	nop
-	nop
-
-	tlbwi
-	COP0_SYNC
-	nop
-	nop
-1:
-	_MTC0	t0, MIPS_COP_0_TLB_HI		# restore current ASID
-	COP0_SYNC
-	mtc0	t3, MIPS_COP_0_TLB_PG_MASK	# restore pgMask
-	COP0_SYNC
-	nop
-	nop
-	j	ra
-	mtc0	v1, MIPS_COP_0_STATUS		# restore status register
-	COP0_SYNC				# XXXX - not executed!!
-END(MIPSX(tlb_invalidate_addr))
-
-/*
- * void mipsN_tlb_invalidate_asids(uint32_t base, uint32_t limit);
- *
- * Invalidate TLB entries belong to per process user spaces with
- * base <= ASIDs < limit while leaving entries for kernel space
- * marked global intact.
- */
-LEAF_NOPROFILE(MIPSX(tlb_invalidate_asids))
-	mfc0	v1, MIPS_COP_0_STATUS		# save status register
-	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
-	COP0_SYNC
-
+/*--------------------------------------------------------------------------
+ *
+ * mipsN_tlb_write_indexed --
+ *
+ *      Write the given entry into the TLB at the given index.
+ *      Pass full R4000 style TLB info including variable page size mask.
+ *
+ *      mipsN_tlb_write_indexed(size_t tlb_index, const struct tlbmask *tlb)
+ *
+ * Results:
+ *      None.
+ *
+ * Side effects:
+ *      TLB entry set.
+ *
+ *--------------------------------------------------------------------------
+ */
+LEAF(MIPSX(tlb_write_indexed))
+	mfc0	v1, MIPS_COP_0_STATUS		# Save the status register.
+	RESET_EXCEPTION_LEVEL_DISABLE_INTERRUPTS(v0)
+	COP0_SYNC
+	INT_L	a2, TLBMASK_LO0(a1)		# fetch tlb->tlb_lo0
+	INT_L	a3, TLBMASK_LO1(a1)		# fetch tlb->tlb_lo1
+	mfc0	v0, MIPS_COP_0_TLB_PG_MASK	# Save current page mask.
 	_MFC0	t0, MIPS_COP_0_TLB_HI		# Save the current PID.
-	mfc0	t1, MIPS_COP_0_TLB_WIRED
-	li	v0, MIPS_KSEG0_START		# invalid address
-	INT_L	t2, _C_LABEL(mips_options) + MO_NUM_TLB_ENTRIES
-	mfc0	t3, MIPS_COP_0_TLB_PG_MASK	# save current pgMask
-
-	# do {} while (t1 < t2)
-1:
-	mtc0	t1, MIPS_COP_0_TLB_INDEX	# set index
-	COP0_SYNC
-	sll	ta0, t1, PGSHIFT + 1		# PAGE_SHIFT + 1
-	nop
-	/* XXX simonb: lose this nop for mips32/64? */
-	nop
-	tlbr					# obtain an entry
-	COP0_SYNC
-	/* XXX simonb: lose these nops for mips32/64? */
-	nop
-	nop
-	nop
-	_MFC0	a0, MIPS_COP_0_TLB_LO1
-	and	a0, MIPS3_PG_G			# check to see it has G bit
-	bnez	a0, 2f				# yep, skip this one.
-	 nop
-	_MFC0	a0, MIPS_COP_0_TLB_HI		# get VA and ASID
-	and	a0, MIPS3_PG_ASID		# focus on ASID
-	sltu	a3, a0, a1			# asid < base?
-	bnez	a3, 2f				# yes, skip this entry.
-	 nop
-	sltu	a3, a0, a2			# asid < limit
-	beqz	a3, 2f				# nope, skip this entry.
-	 nop
-	PTR_ADDU ta0, v0
-
-	_MTC0	ta0, MIPS_COP_0_TLB_HI		# make entryHi invalid
-	COP0_SYNC
-	_MTC0	zero, MIPS_COP_0_TLB_LO0	# zero out entryLo0
-	COP0_SYNC
-	_MTC0	zero, MIPS_COP_0_TLB_LO1	# zero out entryLo1
-	COP0_SYNC
-	mtc0	zero, MIPS_COP_0_TLB_PG_MASK	# zero out mask entry
-	COP0_SYNC
-	/* XXX simonb: lose these nops for mips32/64? */
-	nop
-	nop
-	tlbwi					# invalidate the TLB entry
-	COP0_SYNC
-2:
-	addu	t1, 1
-	bne	t1, t2, 1b
-	 nop
-
-	_MFC0	t0, MIPS_COP_0_TLB_HI		# restore PID.
-	COP0_SYNC
-	mtc0	t3, MIPS_COP_0_TLB_PG_MASK	# restore pgMask
-	COP0_SYNC
-	/* XXX simonb: lose these nops for mips32/64? */
-	nop
-	nop
-	j	ra				# new ASID will be set soon
-	 mtc0	v1, MIPS_COP_0_STATUS		# restore status register
-	COP0_SYNC				# XXXX - not executed!!
-END(MIPSX(tlb_invalidate_asids))
-
-/*
- * u_int mipsN_tlb_record_asids(u_long *bitmap, uint32_t asid_mask);
- *
- * Record all the ASIDs in use in the TLB and return the number of different
- * ASIDs present.
- */
-LEAF_NOPROFILE(MIPSX(tlb_record_asids))
-
-	_MFC0	a3, MIPS_COP_0_TLB_HI		# Save the current PID.
-	mfc0	ta0, MIPS_COP_0_TLB_WIRED
-	INT_L	ta1, _C_LABEL(mips_options) + MO_NUM_TLB_ENTRIES
-	move	ta2, zero
-	li	ta3, 1
-	move	v0, zero
-
-	mfc0	v1, MIPS_COP_0_STATUS		# save status register
-#ifdef _LP64
-	and	t0, v1, MIPS_SR_INT_IE
-	xor	t0, v1
-	mtc0	t0, MIPS_COP_0_STATUS		# disable interrupts
-#else
-	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
-#endif
-	COP0_SYNC
-
-	# do {} while (ta0 < ta1)
-1:
-	mtc0	ta0, MIPS_COP_0_TLB_INDEX	# set index
-	COP0_SYNC
-	nop
-	nop
-	/* XXX simonb: lose this nop for mips32/64? */
-	nop
-	tlbr					# obtain an entry
-	COP0_SYNC
-	/* XXX simonb: lose these nops for mips32/64? */
-	nop
-	nop
-	nop
-	_MFC0	t0, MIPS_COP_0_TLB_LO1
-	and	t0, MIPS3_PG_G			# check to see it has G bit
-	bnez	t0, 4f				# yep, skip this one.
-	 nop
-	_MFC0	t0, MIPS_COP_0_TLB_HI		# get VA and ASID
-	and	t0, a1				# focus on ASID
-
-	srl	a2, t0, 3 + LONG_SCALESHIFT	# drop low 5 or 6 bits
-	sll	a2, LONG_SCALESHIFT		# make an index for the bitmap
-	_SLLV	t0, ta3, t0			# t0 is mask (ta3 == 1)
-
-	PTR_ADDU a2, a0				# index into the bitmap 
-	beq	a2, ta2, 3f			# is the desired cell loaded?
-	 nop					#    yes, don't reload it
-	beqz	ta2, 2f				# have we ever loaded it?
-	 nop					#   nope, so don't save it.
-
-	LONG_S	t2, 0(ta2)			# save the updated value.
-2:
-	move	ta2, a2				# remember the new cell's addr
-	LONG_L	t2, 0(ta2)			# and load it
-3:
-	and	t1, t2, t0			# t1 = t2 & t0
-	sltu	t1, t1, ta3			# t1 = t1 < 1 (aka t1 == 0)
-	addu	v0, t1				# v0 += t1
-	or	t2, t0				# or in the new ASID bits
-4:
-	addu	ta0, 1				# increment TLB entry #
-	bne	ta0, ta1, 1b			# keep lookup if not limit
-	 nop
-
-	beqz	ta2, 5f				# do we have a cell to write?
-	 nop					#   nope.  nothing
-
-	LONG_S	t2, 0(ta2)			# save the updated value.
-5:
-	_MTC0	a3, MIPS_COP_0_TLB_HI		# restore ASID
-	COP0_SYNC
-
-	mtc0	v1, MIPS_COP_0_STATUS		# restore status register
-	j	ra
-	 COP0_SYNC				# XXXX - not executed!!
-END(MIPSX(tlb_record_asids))
-
-/*
- * void mipsN_tlb_invalidate_globals(void);
- *
- * Invalidate the non-wired TLB entries belonging to kernel space while
- * leaving entries for user space (not marked global) intact.
- */
-LEAF_NOPROFILE(MIPSX(tlb_invalidate_globals))
-	mfc0	v1, MIPS_COP_0_STATUS		# save status register
-	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
-	COP0_SYNC
-
-	mfc0	t1, MIPS_COP_0_TLB_WIRED
-	li	v0, MIPS_KSEG0_START		# invalid address
-	INT_L	t2, _C_LABEL(mips_options) + MO_NUM_TLB_ENTRIES
-	mfc0	t3, MIPS_COP_0_TLB_PG_MASK	# save current pgMask
-
-	# do {} while (t1 < t2)
-1:
-	mtc0	t1, MIPS_COP_0_TLB_INDEX	# set index
-	COP0_SYNC
-	sll	ta0, t1, PGSHIFT + 1		# PAGE_SHIFT + 1
-	nop
-	/* XXX simonb: lose this nop for mips32/64? */
-	nop
-	tlbr					# obtain an entry
-	COP0_SYNC
-	/* XXX simonb: lose these nops for mips32/64? */
-	nop
-	nop
-	nop
-	_MFC0	a0, MIPS_COP_0_TLB_LO1
-	and	a0, MIPS3_PG_G			# check to see it has G bit
-	beqz	a0, 2f				# no, skip this entry
-	 nop
-	PTR_ADDU ta0, v0
-
-	_MTC0	ta0, MIPS_COP_0_TLB_HI		# make entryHi invalid
-	COP0_SYNC
-	_MTC0	zero, MIPS_COP_0_TLB_LO0	# zero out entryLo0
-	COP0_SYNC
-	_MTC0	zero, MIPS_COP_0_TLB_LO1	# zero out entryLo1
-	COP0_SYNC
-	mtc0	zero, MIPS_COP_0_TLB_PG_MASK	# zero out mask entry
-	COP0_SYNC
-	/* XXX simonb: lose these nops for mips32/64? */
-	nop
-	nop
-	tlbwi					# invalidate the TLB entry
-	COP0_SYNC
-2:
-	addu	t1, 1
-	bne	t1, t2, 1b
-	nop
-
-	mtc0	t3, MIPS_COP_0_TLB_PG_MASK	# restore pgMask
-	COP0_SYNC
-	/* XXX simonb: lose these nops for mips32/64? */
-	nop
-	nop
-	j	ra				# new ASID will be set soon
-	 mtc0	v1, MIPS_COP_0_STATUS		# restore status register
-	COP0_SYNC				# XXXX - not executed!!
-END(MIPSX(tlb_invalidate_globals))
-
-/*
- * void mipsN_tlb_invalidate_all(void);
- *
- * Invalidate all of non-wired TLB entries.
- */
-LEAF_NOPROFILE(MIPSX(tlb_invalidate_all))
-	mfc0	v1, MIPS_COP_0_STATUS		# save status register
-	mtc0	zero, MIPS_COP_0_STATUS		# disable interrupts
-	COP0_SYNC
-
-	INT_L	a0, _C_LABEL(mips_options) + MO_NUM_TLB_ENTRIES
-
-	li	v0, MIPS_KSEG0_START		# invalid address
-	_MFC0	t0, MIPS_COP_0_TLB_HI		# save current ASID
-	mfc0	t1, MIPS_COP_0_TLB_WIRED
-	mfc0	t2, MIPS_COP_0_TLB_PG_MASK	# save current pgMask
-
-	_MTC0	zero, MIPS_COP_0_TLB_LO0	# zero out entryLo0
-	COP0_SYNC
-	_MTC0	zero, MIPS_COP_0_TLB_LO1	# zero out entryLo1
-	COP0_SYNC
-	mtc0	zero, MIPS_COP_0_TLB_PG_MASK	# zero out pageMask
-	COP0_SYNC
-
-	# do {} while (t1 < a0)
-1:
-	mtc0	t1, MIPS_COP_0_TLB_INDEX	# set TLBindex
-	COP0_SYNC
-	sll	ta0, t1, PGSHIFT + 1		# PAGE_SHIFT + 1
-	PTR_ADDU ta0, v0
-	_MTC0	ta0, MIPS_COP_0_TLB_HI		# make entryHi invalid
-	COP0_SYNC
-	nop
-	nop
-	tlbwi					# clear the entry
-	COP0_SYNC
-	addu	t1, 1				# increment index
-	bne	t1, a0, 1b
-	 nop
-
-	_MTC0	t0, MIPS_COP_0_TLB_HI		# restore ASID
-	COP0_SYNC
-	mtc0	t2, MIPS_COP_0_TLB_PG_MASK	# restore pgMask
-	COP0_SYNC
-	nop
-	nop
-	j	ra
-	 mtc0	v1, MIPS_COP_0_STATUS		# restore status register
-	COP0_SYNC				# XXXX - not executed!!
-END(MIPSX(tlb_invalidate_all))
-
-/*
- * mipsX_tlb_enter(size_t tlb_index, vaddr_t va, uint32_t pte);
- */
-LEAF(MIPSX(tlb_enter))
+
+	_MTC0	a2, MIPS_COP_0_TLB_LO0		# Set up entry low0.
+	_MTC0	a3, MIPS_COP_0_TLB_LO1		# Set up entry low1.
+	COP0_SYNC
+	INT_L	a2, TLBMASK_MASK(a1)		# fetch tlb->tlb_mask
+	PTR_L	a3, TLBMASK_HI(a1)		# fetch tlb->tlb_hi
+	mtc0	a0, MIPS_COP_0_TLB_INDEX	# Set the index.
+	mtc0	a2, MIPS_COP_0_TLB_PG_MASK	# Set up entry pagemask.
+	_MTC0	a3, MIPS_COP_0_TLB_HI		# Set up entry high.
+	COP0_SYNC
+	tlbwi					# Write the TLB
+	COP0_SYNC
+
+	_MTC0	t0, MIPS_COP_0_TLB_HI		# Restore the PID.
+	mtc0	v0, MIPS_COP_0_TLB_PG_MASK	# Restore page mask.
+	COP0_SYNC
+	mtc0	v1, MIPS_COP_0_STATUS		# Restore the status register
+	JR_HB_RA
+END(MIPSX(tlb_write_indexed))
+
+#if defined(MIPS3)
+/*----------------------------------------------------------------------------
+ *
+ * mipsN_VCED --
+ *
+ *	Handle virtual coherency exceptions.
+ *	Called directly from the mips3 exception-table code.
+ *	only k0, k1 are available on entry
+ *
+ * Results:
+ *	None.
+ *
+ * Side effects:
+ *	Remaps the conflicting address as uncached and returns
+ *	from the exception.
+ *
+ *	NB: cannot be profiled, all registers are user registers on entry.
+ *
+ *----------------------------------------------------------------------------
+ */
+LEAF_NOPROFILE(MIPSX(VCED))
 	.set	noat
-	mfc0	ta0, MIPS_COP_0_TLB_HI		# save EntryHi
-
-	and	a3, a1, MIPS3_PG_ODDPG		# select odd page bit
-	xor	a3, a1				# clear it.
-	mtc0	a3, MIPS_COP_0_TLB_HI		# set the VA for tlbp
-	COP0_SYNC
-	nop
-	nop
-
-	and	t2, a2, MIPS3_PG_G		# make prototype tlb_lo0
-	and	t3, a2, MIPS3_PG_G		# make prototype tlb_lo1
-
-	tlbp					# is va in TLB?
-	nop
-	nop
-	nop
-
-	mfc0	v0, MIPS_COP_0_TLB_INDEX	# was it in the TLB?
-	bltz	v0, 1f				# nope
-	 nop
-
-	/*
-	 * Get the existing tlb_lo's because we need to replace one of them.
-	 */
-	mfc0	t2, MIPS_COP_0_TLB_LO0		# save for update
-	mfc0	t3, MIPS_COP_0_TLB_LO1		# save for update
-
-	/*
-	 * If it's already where we want, no reason to invalidate it.
-	 */
-	beq	v0, a0, 2f			# already where we want it?
-	 nop					
-
-	/*
-	 * Make an
-	 */
-	sll	t1, 1 + PGSHIFT			# make a fake addr for the entry
-	lui	v1, %hi(MIPS_KSEG0_START)
-	or	t1, v1
-	mtc0	t1, MIPS_COP_0_TLB_HI
-	COP0_SYNC
-	nop
-	nop
-
-	and	t0, a2, MIPS3_PG_G		# make prototype tlb_lo
-	mtc0	t0, MIPS_COP_0_TLB_LO0		# use an invalid tlb_lo
-	COP0_SYNC
-	mtc0	t0, MIPS_COP_0_TLB_LO1		# use an invalid tlb_lo
-	COP0_SYNC
-
-	tlbwi					# now write the invalid TLB
-	COP0_SYNC
-
-	mtc0	a3, MIPS_COP_0_TLB_HI		# restore the addr for new TLB
-	COP0_SYNC
-	nop
-	nop
-1:
-	mtc0	a0, MIPS_COP_0_TLB_INDEX	# set the index
-	COP0_SYNC
-
-2:
-	and	v1, a1, MIPS3_PG_ODDPG		# odd or even page
-	sll	v1, 31 - PGSHIFT		# move to MSB
-	sra	v1, 31				# v1 a mask (0/~0 = even/odd)
-	not	v0, v1				# v0 a mask (~0/0 = even/odd)
-
-	and	ta2, t2, v1
-	and	ta3, a2, v0
-	or	t2, ta2, ta3			# t2 = (v1 & t2) | (~v1 & a2)
-	and	ta2, t3, v0
-	and	ta3, a2, v1
-	or	t3, ta2, ta3			# t3 = (~v1 & t3) | (v1 & a2)
-
-	mtc0	t2, MIPS_COP_0_TLB_LO0		# set tlb_lo0 (even)
-	COP0_SYNC
-	mtc0	t3, MIPS_COP_0_TLB_LO1		# set tlb_lo1 (odd)
-	COP0_SYNC
-
-	tlbwi					# enter it into the TLB
-	nop
-	nop
-	nop
-
-	mtc0	ta1, MIPS_COP_0_TLB_HI		# restore EntryHi
-	COP0_SYNC
-
-	j	ra
-	 nop
+	_MFC0	k0, MIPS_COP_0_BAD_VADDR	# fault addr.
+	li	k1, -16
+	and	k0, k1
+	cache	(CACHE_R4K_SD | CACHEOP_R4K_HIT_WB_INV), 0(k0)
+	cache	(CACHE_R4K_D | CACHEOP_R4K_HIT_INV), 0(k0)
+#ifdef DEBUG
+	_MFC0	k0, MIPS_COP_0_BAD_VADDR
+	PTR_LA	k1, VCED_vaddr
+	PTR_S	k0, 0(k1)
+	_MFC0	k0, MIPS_COP_0_EXC_PC
+	PTR_LA	k1, VCED_epc
+	PTR_S	k0, 0(k1)
+	PTR_LA	k1, VCED_count		# count number of exceptions
+	PTR_SRL	k0, k0, 26		# position upper 4 bits of VA
+	and	k0, k0, 0x3c		# mask it off
+	PTR_ADDU k1, k0			# get address of count table
+	LONG_L	k0, 0(k1)
+	LONG_ADDU k0, 1
+	LONG_S	k0, 0(k1)
+#endif
+	eret
 	.set	at
-END(MIPSX(tlb_enter))
+
+#ifdef DEBUG
+	.data
+	.globl	_C_LABEL(VCED_count)
+_C_LABEL(VCED_count):
+	LONG_WORD	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+	.globl	_C_LABEL(VCED_epc)
+_C_LABEL(VCED_epc):
+	PTR_WORD	0
+	.globl	_C_LABEL(VCED_vaddr)
+_C_LABEL(VCED_vaddr):
+	PTR_WORD	0
+	.text
+#endif
+END(MIPSX(VCED))
+
+LEAF_NOPROFILE(MIPSX(VCEI))
+	.set	noat
+	_MFC0	k0, MIPS_COP_0_BAD_VADDR	# fault addr.
+	cache	(CACHE_R4K_SD | CACHEOP_R4K_HIT_WB_INV), 0(k0)
+	cache	(CACHE_R4K_I | CACHEOP_R4K_HIT_INV), 0(k0)
+#ifdef DEBUG
+	_MFC0	k0, MIPS_COP_0_BAD_VADDR
+	PTR_LA	k1, VCEI_vaddr
+	PTR_S	k0, 0(k1)
+	PTR_LA	k1, VCEI_count		# count number of exceptions
+	PTR_SRL	k0, k0, 26		# position upper 4 bits of VA
+	and	k0, k0, 0x3c		# mask it off
+	PTR_ADDU k1, k0			# get address of count table
+	LONG_L	k0, 0(k1)
+	PTR_ADDU k0, 1
+	LONG_S	k0, 0(k1)
+#endif
+	eret
+	.set	at
+
+#ifdef DEBUG
+	.data
+	.globl	_C_LABEL(VCEI_count)
+_C_LABEL(VCEI_count):
+	LONG_WORD	0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
+	.globl	_C_LABEL(VCEI_vaddr)
+_C_LABEL(VCEI_vaddr):
+	PTR_WORD	0
+	.text
+#endif
+END(MIPSX(VCEI))
+#endif /* MIPS3 */
 #endif /* !TSAR */
 
@@ -2716,4 +2681,8 @@
 _C_LABEL(MIPSX(locore_vec)):
 #ifndef TSAR
+	PTR_WORD _C_LABEL(MIPSX(cpu_switch_resume))
+	PTR_WORD _C_LABEL(MIPSX(lwp_trampoline))
+	PTR_WORD _C_LABEL(MIPSX(setfunc_trampoline))
+	PTR_WORD _C_LABEL(MIPSX(wbflush)) # wbflush
 	PTR_WORD _C_LABEL(MIPSX(tlb_set_asid))
 	PTR_WORD _C_LABEL(MIPSX(tlb_invalidate_asids))
@@ -2722,8 +2691,13 @@
 	PTR_WORD _C_LABEL(MIPSX(tlb_invalidate_all))
 	PTR_WORD _C_LABEL(MIPSX(tlb_record_asids))
-	PTR_WORD _C_LABEL(MIPSX(tlb_update))
+	PTR_WORD _C_LABEL(MIPSX(tlb_update_addr))
 	PTR_WORD _C_LABEL(MIPSX(tlb_enter))
 	PTR_WORD _C_LABEL(MIPSX(tlb_read_indexed))
-#else
+	PTR_WORD _C_LABEL(MIPSX(tlb_write_indexed))
+#else
+	PTR_WORD _C_LABEL(nullop)
+	PTR_WORD _C_LABEL(MIPSX(lwp_trampoline))
+	PTR_WORD _C_LABEL(MIPSX(setfunc_trampoline))
+	PTR_WORD _C_LABEL(MIPSX(wbflush)) # wbflush
 	PTR_WORD 0
 	PTR_WORD 0
@@ -2735,21 +2709,16 @@
 	PTR_WORD 0
 	PTR_WORD 0
-#endif
-	PTR_WORD _C_LABEL(MIPSX(wbflush))
+	PTR_WORD 0
+#endif
 
 	.globl _C_LABEL(MIPSX(locoresw))
 _C_LABEL(MIPSX(locoresw)):
-#ifdef TSAR
-	PTR_WORD _C_LABEL(nullop)
-#else
-	PTR_WORD _C_LABEL(MIPSX(cpu_switch_resume))
-#endif
-	PTR_WORD _C_LABEL(MIPSX(lwp_trampoline))
-	PTR_WORD _C_LABEL(nullop)	# cpu_idle
-	PTR_WORD _C_LABEL(MIPSX(setfunc_trampoline))
-	PTR_WORD _C_LABEL(nullop)	# send ipi
-	PTR_WORD _C_LABEL(nullop)	# cpu_offline_md
-	PTR_WORD _C_LABEL(nullop)	# spare
-	PTR_WORD _C_LABEL(nullop)	# spare
+	PTR_WORD _C_LABEL(MIPSX(wbflush))	# lsw_wbflush
+	PTR_WORD _C_LABEL(nullop)		# lsw_cpu_idle
+	PTR_WORD _C_LABEL(nullop)		# lsw_send_ipi
+	PTR_WORD _C_LABEL(nullop)		# lsw_cpu_offline_md
+	PTR_WORD _C_LABEL(nullop)		# lsw_cpu_init
+	PTR_WORD _C_LABEL(nullop)		# lsw_cpu_run
+	PTR_WORD _C_LABEL(nullop)		# lsw_bus_error
 
 MIPSX(excpt_sw):
@@ -2776,6 +2745,6 @@
 	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))	# 12 arithmetic overflow
 	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))	# 13 r4k trap exception
-#if defined(MIPS3) && !defined(MIPS3_5900) && !defined(TSAR)
-	PTR_WORD _C_LABEL(mips3_VCEI)			# 14 r4k virt coherence
+#if defined(MIPS3) && !defined(TSAR)
+	PTR_WORD _C_LABEL(MIPSX(VCEI))			# 14 r4k virt coherence
 #else
 	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))	# 14 reserved
@@ -2797,6 +2766,6 @@
 	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))	# 29 reserved
 	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))	# 30 reserved
-#if defined(MIPS3) && !defined(MIPS3_5900) && !defined(TSAR)
-	PTR_WORD _C_LABEL(mips3_VCED)		# 31 v. coherence exception data
+#if defined(MIPS3) && !defined(TSAR)
+	PTR_WORD _C_LABEL(MIPSX(VCED))			# 31 v. coherence exception data
 #else
 	PTR_WORD _C_LABEL(MIPSX(kern_gen_exception))	# 31 reserved
@@ -2815,10 +2784,10 @@
 	PTR_WORD _C_LABEL(MIPSX(systemcall))		#  8
 	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))	#  9
-	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))	# 10
+	PTR_WORD _C_LABEL(MIPSX(user_reserved_insn))	# 10
 	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))	# 11
 	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))	# 12
 	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))	# 13
-#if defined(MIPS3) && !defined(MIPS3_5900) && !defined(TSAR)
-	PTR_WORD _C_LABEL(mips3_VCEI)			# 14
+#if defined(MIPS3) && !defined(TSAR)
+	PTR_WORD _C_LABEL(MIPSX(VCEI))			# 14
 #else
 	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))	# 14
@@ -2840,6 +2809,6 @@
 	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))	# 29
 	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))	# 30
-#if defined(MIPS3) && !defined(MIPS3_5900) && !defined(TSAR)
-	PTR_WORD _C_LABEL(mips3_VCED)			# 31 v. coherence exception data
+#if defined(MIPS3) && !defined(TSAR)
+	PTR_WORD _C_LABEL(MIPSX(VCED))			# 31 v. coherence exception data
 #else
 	PTR_WORD _C_LABEL(MIPSX(user_gen_exception))	# 31
